/*
 *  CIntendation.c
 *  Intender
 *
 *  Created by Lucas on 20/01/2007.
 *  Distributed under the GNU General Public Licence
 *
 */

#include "inc/html.h"
#include "inc/tools.h"
#include <stdlib.h>
#include <string.h>

/* macros ============================================================== */

#define NO 0
#define YES 1

/* constants =========================================================== */

typedef enum
{
	black = 0,
	red = 1,
	blue = 2,
	green = 3,
	blockGreen = 4,
	string = 5,
	macro = 6
}
Color;

#define VOCAB_COUNT 26
char *vocab[26] =
{ "if", "else", "switch", "case",
	"break", "default", "NULL", "for",
	"while", "return", "const", "static",
	"unsigned", "char", "short", "int",
	"long", "double", "float", "void",
	"sizeof", "typedef", "enum", "struct",
	"union", "extern" };

/* types =============================================================== */
/* structures ========================================================== */

struct encoder
{
	char *shtml; // mou...
	char *currentWord;
	Color currentColor;
};

/* private variables =================================================== */

/* private functions =================================================== */

static unsigned char str_cmp (char const *str1, char const *str2)
{
	return strcmp (str1 ? str1 : "", str2 ? str2 : "") == 0 ? YES : NO;
	// ah oui, euh, je maitrise pas encore ce genre de syntaxe, en fait j'ai jamais su ce que a voulait dire
	// c'est assez difficile de faire une recherche sur des ? et des :
}

static void breakWordAndAddChar (struct encoder *p, int chr)
{
	unsigned char foundWord = 0;
	
	if (str_cmp (p->currentWord, "//"))
	{
		if ((p->currentColor != black) && (p->currentColor != green)
			&& (p->currentColor != blockGreen) && (p->currentColor != string))
			p->shtml = str_cat (p->shtml, "</span>");
		
		if ((p->currentColor != green) && (p->currentColor != blockGreen)
			&& (p->currentColor != string))
		{
			p->shtml = str_cat (p->shtml, "<span class=\"green\">//");
			p->currentColor = green;
		}
		else
		{
			p->shtml = str_cat (p->shtml, "//");
		}
		
		p->currentWord = NULL;
		foundWord = 1;
	}
	else if (str_cmp (p->currentWord, "/*") == YES)
	 {
		if ((p->currentColor != green) && (p->currentColor != blockGreen) &&
			(p->currentColor != black) && (p->currentColor != string)
			&& (p->currentColor != blue))
		{
			p->shtml = str_cat (p->shtml, "</span>");
		}
		if ((p->currentColor != green) && (p->currentColor != blockGreen)
			&& (p->currentColor != string))
		{
			p->shtml = str_cat (p->shtml, "<span class=\"green\">");
			p->currentColor = blockGreen;
		}
		p->shtml = str_cat (p->shtml, "/*");
		 
		 p->currentWord = NULL;
		 foundWord = 1;
	 }
		 else if (str_cmp (p->currentWord, "*/") == YES) // ya un bug de mon IDE pour l'indentation  partir d'ici
{
			 p->shtml = str_cat (p->shtml, "*/");
			 
			 if (p->currentColor == blockGreen)
			 {
				 p->shtml = str_cat (p->shtml, "</span>");
				 p->currentColor = black;
			 }
			 
			 p->currentWord = NULL;
			 foundWord = 1;
}

if (!foundWord){
			 unsigned int itm = 0;
			 for (itm = 0;itm < VOCAB_COUNT;itm++){
				 if (str_cmp (p->currentWord, vocab[itm]) == YES){
					 if ((p->currentColor != green) && (p->currentColor != blockGreen)
						 && (p->currentColor != string))
					 {
						 p->shtml = str_cat (p->shtml, "<span class=\"red\">");
						 p->shtml = str_cat (p->shtml, vocab[itm]);
						 p->shtml = str_cat (p->shtml, "</span>");
					 }
					 else
					 {
						 p->shtml = str_cat (p->shtml, vocab[itm]);
					 }
					 p->currentWord = NULL;
					 foundWord = 1;
				 }
			 }
}

if (!foundWord)
{
			 p->shtml = str_cat (p->shtml, p->currentWord);
			 p->currentWord = NULL;
			 foundWord = 1;
}
if (chr == '<')
{
			 p->shtml = str_cat (p->shtml, "&lt;");
}
else if (chr == '>')
{
			 p->shtml = str_cat (p->shtml, "&gt;");
}
else if (chr == '&')
{
			 p->shtml = str_cat (p->shtml, "&amp;");
}
else if (chr == '\t')
{
			 p->shtml = str_cat (p->shtml, "    ");
}
else
{
			 /* -ed- conversion de chr en chaine */
			 char chaine[2] = { chr };
			 p->shtml = str_cat (p->shtml, chaine);
}
}

void addBasicLetterToWord (struct encoder *p, int chr)
{
	char chaine[2] = { chr };
	p->currentWord = str_cat (p->currentWord, chaine);
	
//	if (str_cmp (p->currentWord, "//"))
//	{
//		if ((p->currentColor != black) && (p->currentColor != green) && (p->currentColor != macro)
//			&& (p->currentColor != blockGreen) && (p->currentColor != string))
//			p->shtml = str_cat (p->shtml, "</span>");
//		
//		if ((p->currentColor != green) && (p->currentColor != blockGreen)
//			&& (p->currentColor != string))
//		{
//			p->shtml = str_cat (p->shtml, "<span class=\"green\">//");
//			p->currentColor = green;
//		}
//		else
//		{
//			p->shtml = str_cat (p->shtml, "//");
//		}
//		
//		p->currentWord = NULL;
//		
//	}
//	else if (str_cmp (p->currentWord, "/*"))
//	 {
//		if ((p->currentColor != green) && (p->currentColor != blockGreen) &&
//			(p->currentColor != black) && (p->currentColor != string)
//			&& (p->currentColor != blue))
//		{
//			p->shtml = str_cat (p->shtml, "</span>");
//		}
//		if ((p->currentColor != green) && (p->currentColor != blockGreen)
//			&& (p->currentColor != string))
//		{
//			p->shtml = str_cat (p->shtml, "<span class=\"green\">");
//			p->currentColor = blockGreen;
//		}
//		p->shtml = str_cat (p->shtml, "/*");
//		 
//		 p->currentWord = NULL;
//		 
//	 }
//		 else if ((strpbrk (p->currentWord, "*/") != NULL))
//{
//			 p->shtml = str_cat (p->shtml, p->currentWord);
//			 
//			 if (p->currentColor == blockGreen)
//			 {
//				 p->shtml = str_cat (p->shtml, "</span>");
//				 p->currentColor = black;
//			 }
//			 
//			 p->currentWord = NULL;
//}
}

static void treatChar (struct encoder *p, int aChr)
{
	switch (aChr)
	{
		case ' ':
			breakWordAndAddChar (p, ' ');
			break;
		case '\n':
			breakWordAndAddChar (p, ' ');
			if ((p->currentColor != black) && (p->currentColor != blockGreen))
			{
				p->shtml = str_cat (p->shtml, "</span>");
				p->currentColor = black;
			}
				
				p->shtml = str_cat (p->shtml, "\n ");
			break;
		case '\t':
			breakWordAndAddChar (p, '\t');
			break;
		case '\'':
			if ((p->currentColor != green) && (p->currentColor != blockGreen))
			{
				if (p->currentColor == blue)
				{
					breakWordAndAddChar (p, '\'');
					p->shtml = str_cat (p->shtml, "</span>");
					p->currentColor = black;
				}
				else if ((p->currentColor == string) || (p->currentColor == green)
						 || (p->currentColor == blockGreen) || (p->currentColor == red)
						 || (p->currentColor == macro))
				{
					breakWordAndAddChar (p, '\'');
				}
				else
				{
					p->shtml =
					str_cat (p->shtml, "<span class =\"blue\">");
					breakWordAndAddChar (p, '\'');
					p->currentColor = blue;
				}
			}
			
			else
			{
				breakWordAndAddChar (p, '\'');
			}
			
			break;
		case '\"':
			if ((p->currentColor != green) && (p->currentColor != blockGreen)
				&& (p->currentColor != macro))
		{
				if (p->currentColor == string)
				{
					breakWordAndAddChar (p, '\"');
					p->shtml = str_cat (p->shtml, "</span>");
					p->currentColor = black;
				}
				else
				{
					p->shtml =
					str_cat (p->shtml, "<span class=\"red\">");
					breakWordAndAddChar (p, '\"');
					p->currentColor = string;
				}
		}
      else
      {
		  breakWordAndAddChar (p, '\"');
      }

      break;
   case '#':
	   if ((p->currentColor != green) && (p->currentColor != blockGreen)
		   && (p->currentColor != string))
	   {
		   p->shtml = str_cat (p->shtml, "<span class=\"macro\">");
		   p->currentColor = macro;
	   }
	   breakWordAndAddChar (p, '#');
	   break;
	   
   default:
	   if (strchr ("<>(){}[]:;-+=,", aChr) != NULL)
	   {
		   breakWordAndAddChar (p, aChr);
	   }
	   else
	   {
		   addBasicLetterToWord (p, aChr);
	   }
	   break;
	}
}

/* internal public functions =========================================== */
/* entry points ======================================================== */

char *html_c_encoder (char const *aString)
{	
	struct encoder encoder;
	
	encoder.currentWord = NULL;
	encoder.currentColor = black;
	encoder.shtml =
		strdup ("\n<span class=\"green\">"
				"/* Indented and colored by " PRJ " " VER " " __DATE__ " "
				 __TIME__ "\n" " * " CPY1 "\n" " * " CPY2 "\n" " */</span>\n");
	
	size_t len = strlen (aString);
	size_t i;
	
	for (i = 0; i < len; i++)
	{
		treatChar (&encoder, aString[i]);
	}
	treatChar (&encoder, '\n');
	
	return encoder.shtml;
}

char *html_cpp_encoder (char const *s)
{
	TO_DO (html_cpp_encoder);
}

/* public variables ==================================================== */
