
/*
 *  Intender.c
 *  Intender
 *
 *  Created by Lucas on 07/12/2006.
 *  Distributed under the GNU General Public Licence
 *
 */

// pti test de commentaire simple

#include "inc/html.h"           /* -ed- '>' en trop */
#include "inc/tools.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

/* macros ============================================================== */

#define DEBUG 1
#if 1
#define DEBUG_SRC "/Users/lucas/Desktop/Indenteur/src/main.c"
#define DEBUG_TITLE "main.c"
#define DEBUG_DESTINATION DEBUG_SRC ".html"
#else
#define DEBUG_SRC "main.c"
#define DEBUG_TITLE DEBUG_SRC
#define DEBUG_DESTINATION DEBUG_SRC ".html"
#endif

/* constants =========================================================== */
/* types =============================================================== */
/* structures ========================================================== */
/* private variables =================================================== */
/* private functions =================================================== */

static char const *getSrcPath (void)
{
#if DEBUG
	return DEBUG_SRC;
#else
	char path[1000];
	printf
		("Entrez l'adresse complete du fichier contenant le code a convertir pour le Web :\n->");
	scanf ("%s", path);
	printf ("\n");
	if (path == NULL)
	{
		printf ("Adresse invalide.");
		free (path);
		exit (1);
	}
	
	return strdup(path);
#endif
}

static char const *getTitle (void)
{
#if DEBUG
	return DEBUG_TITLE;
#else
	printf ("Creation des en-tetes...\nEntrez le titre a afficher :\n->");
	char title[1000];
	scanf ("%s", title);
	return strdup(title);;
#endif
}

char const *getDestinationPath (void)
{
#if DEBUG
	return DEBUG_DESTINATION;
#else
	char path[1000];
	printf
		("Entrez l'adresse complete du fichier ou vous souhaitez enregistrer le code cree :\n->");
	scanf ("%s", path);
	printf ("\n");
	/* -ed- comment un tableau pourrait il e^tre NULL ?
		if (path == NULL)
	{
			printf ("Adresse invalide.");
			exit (1);
	}
	*/
	/* -ed- NON, on a pas le droit de retourner l'adresse d'un tableau local... */
	return strdup(path);
#endif
}

/* entry points ======================================================== */

int main (void)
{
	char *data = NULL;
	
	printf ("\nBienvenue dans " PRJ " " VER "\n" CPY1 "\n" CPY2 "\n");
	// cool... je savais pas qu'on pouvait reconstituer des chaines de caractre comme a
	printf ("\nInitialisation de " PRJ "...\n\n");
	{
		char const *cPath = getSrcPath ();
		
		data = readFromFile (cPath);
		if (data != NULL)
		{
			printf ("Lecture du fichier %s en cours ...\n", cPath);
		}
		else
		{
			printf ("Fichier %s introuvable.\n", cPath);
			return EXIT_FAILURE;
		}
	}
	
	printf ("Creation du code HTML...\n");
	{
		char *shtml = html_c_encoder (data);
		
		free (data), data = NULL;
		if (shtml != NULL)
		{
			printf ("Code cree...\n");
			
			char *cFinalData = str_cat (NULL,
										"<style type=\"text/css\">\n"
										".red{ color:" KEYWORD "; }\n"
										".green{ color:" COMMENT "; }\n"
										".blue{ color:" BLUE "; }\n"
										".macro{ color:" MACRO "; }\n"
										".str{ color:" STRING "; }\n" "</style>");
			{
				char *cTitle = strdup ("<span class=\"newtitle\">");
				char const *title = getTitle ();
				if (strcmp (title, "") != 0)
					cTitle = str_cat (cTitle, title);
				else
					cTitle = str_cat (cTitle, "Titre");
				
				cTitle =
					str_cat (cTitle,
							 "</span><br />\n<div id=\"code\"><br />\n\n<pre>\n");
				cFinalData = str_cat (cFinalData, cTitle);
				free (cTitle), cTitle = NULL;
			}
			cFinalData = str_cat (cFinalData, shtml);
			free (shtml), shtml = NULL;
			cFinalData = str_cat (cFinalData, "</pre>\n</div>\n</span>\n");
			
			printf ("Enregistrement du code...\n");
			{
				char const *destPath = getDestinationPath ();
				char *cDestination = strdup (destPath);
				
				printf ("Enregistrement du fichier %s...\n", cDestination);
				{
					int ok = writeToFile (cDestination, cFinalData);
					free (cFinalData), cFinalData = NULL;
					
					if (!ok)
					{
						printf ("Erreur lors de l'enregistrement du fichier %s.\n",
								cDestination);
					}
					else
					{
						printf ("Fichier %s enregistre avec succes.\n",
								cDestination);
					}
					free (cDestination), cDestination = NULL;
				}
			}
		}
		else
		{
			printf ("Erreur lors de la creation du code.\n");
			return 0;
		}
	}
	
	return 0;
}
